// EngineConfig struct public header
#pragma once

namespace nf {
    enum class DisplayMode {
        Windowed,
        Fullscreen
    };

    struct DisplayConfig {
        DisplayMode mode;
        unsigned int width, height;

        DisplayConfig()
            : mode(DisplayMode::Windowed)
            , width(1280)
            , height(720)
        {}
    };

    struct ClientConfig {
        const char* appName;
        const char* appVersion;
        DisplayConfig display;

        ClientConfig()
            : appName("Nothin' Fancy Game")
            , appVersion("v0.1.0")
            , display()
        {}
    };
}
