// NF logging and error system header
#pragma once

// Define NFLog
#ifdef _DEBUG // Debug builds
#define NFLog(x) ::nf::util::log(x, ::nf::util::LogType::Log)
#else // Release builds
#define NFLog(x)
#endif

// Define NFError
#define NFError(x) ::nf::util::error(x, __FILE__, __LINE__)

namespace nf::util {
    enum class LogType {
        Log,
        Timing,
        Error
    };

    void log(const char* msg, LogType type);
    void log(const std::string& msg, LogType type);

    template<typename T>
    void log(T data, LogType type) {
        log(std::to_string(data), type);
    }

    void error(const char* msg, const char* file, unsigned int line);
}
